// IndustryPackModule.h

/********************COPYRIGHT NOTIFICATION**********************************
  This software was developed under a United States Government license
  described on the COPYRIGHT_UniversityOfChicago file included as part
  of this distribution.
  ***************************************************************************
  */
/*
  Current Author: Thomas Coleman
  Original Author: Jim Kowalkowski (for Hideos)
  Date: 09JUL98
  */

#ifndef IndustryPackModuleH
#define IndustryPackModuleH

#include "IndustryPackCarrier.h"

class IndustryPackModule
{
 public:
  static IndustryPackModule * createIndustryPackModule
    (const char *moduleName, const char *carrierName, const char *siteName);
  static IndustryPackModule *find(const char *moduleName);
  static IndustryPackModule *find(const char *carrierName, const char *siteName);
  volatile void *allocMemMapIP(int size);
  int intConfig(int num);
  int intEnable(int num);
  int intDisable(int num);
  int intClear(int num);
  volatile IP_ID_PROM *getMemBaseID();
  volatile void *getMemBaseIO();
  volatile void *getMemBaseIP();
  int getMemSizeIP();
  unsigned char getManufacturer();
  unsigned char getModel();
  unsigned char getRevision();
 private:
  IndustryPackModule
    (const char *moduleName, IndustryPackCarrier *pCarrier, IndustryPackSite *pSite);
  const char *moduleName;
  volatile IP_ID_PROM *memBaseID;
  volatile void *memBaseIO;
  volatile void *memBaseIP;
  int memSizeIP;
  IndustryPackCarrier *pIpCarrier;
  IndustryPackSite *pIpSite;
};

#endif /* IndustryPackModuleH */

