// ConnectMessage.cc

#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include "Message.h"
#define ConnectMessageDEFINE
#include "ConnectMessage.h"
#undef ConnectMessageDEFINE

DLList* ConnectMessage::pFreeList = 0;

int32 ConnectMessage:: toBuffer(char **buffer) const
{
    int16 ival;
    int32 nbytes;

    nbytes = Message::toBuffer(buffer);
    ival = (int16)status;
    nbytes += MPF::toBuffer(buffer,ival);
    return(nbytes);
}

int32 ConnectMessage:: fromBuffer(const char **buffer)
{
    int16 ival;
    int32 nbytes=0;

    nbytes = Message::fromBuffer(buffer);
    nbytes += MPF::fromBuffer(buffer,&ival);
    status = (connectStatus)ival;
    return(nbytes);
}

int32 ConnectMessage:: fromBufferSwitch(const char **buffer)
{
    int16 ival;
    int32 nbytes=0;

    nbytes = Message::fromBufferSwitch(buffer);
    nbytes += MPF::fromBufferSwitch(buffer,&ival);
    status = (connectStatus)ival;
    return(nbytes);
}

void ConnectMessage:: print() const
{
    Message::print();
    printf("status %d %s\n",status,connectStatusString[status]);
}

void *ConnectMessage:: operator new(size_t size)
{
    if(size==sizeof(ConnectMessage)) return MPF:: allocate(&pFreeList,size);
    printf("ConnectMessage new size !=sizeof(ConnectMessage)\n");
    return(0);
}

void ConnectMessage:: operator delete(void *p, size_t size)
{
    ConnectMessage *pmessage = (ConnectMessage *)p;
    if(size==sizeof(ConnectMessage)) {
        MPF::free(pFreeList,p,size);
        return;
    }
    printf("ConnectMessage delete size !=sizeof(ConnectMessage)\n");
}
