// serverChar8Array.cc
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

#include <taskLib.h>

#include "Message.h"
#include "Char8ArrayMessage.h"

int serverChar8ArrayDebug=0;

class ServerChar8Array {
public:
    ServerChar8Array(const char *name,int queueSize);
    static void server(ServerChar8Array *);
private:
    MessageServer *pMessageServer;
};

ServerChar8Array::ServerChar8Array(const char *name,int queueSize)
{
    pMessageServer = new MessageServer(name,queueSize);
}

static char taskname[] = "serverChar8Array";
extern "C" int initServerChar8Array(const char *serverName,int queueSize)
{
    ServerChar8Array *pServerChar8Array =
        new ServerChar8Array(serverName,queueSize);
    int taskId = taskSpawn(taskname,100,VX_FP_TASK,2000,
        (FUNCPTR)ServerChar8Array::server,(int)pServerChar8Array,
        0,0,0,0,0,0,0,0,0);
    if(taskId==ERROR)
        printf("initServerChar8Array taskSpawn Failure\n");
    return(0);
}

void ServerChar8Array::server(ServerChar8Array *pServerChar8Array)
{
    MessageServer *pMessageServer = pServerChar8Array->pMessageServer;
    Message       *message;
    bool allocNew = false;
    while(TRUE) {
	pMessageServer->waitForMessage();
	while((message = pMessageServer->receive())) {
	    if(message->getType()!=messageTypeChar8Array) {
	        printf("serverChar8Array got illegal message type %d\n",
		    message->getType());
	    } else {
		Char8ArrayMessage  *preceive = (Char8ArrayMessage *)message;
		Char8ArrayMessage *psend;
		if(allocNew) {
		    psend = (Char8ArrayMessage *)pMessageServer->
			allocReplyMessage(preceive,messageTypeChar8Array);
		    psend->allocValue(preceive->getSize());
		    ::strcpy(psend->value,preceive->value);
		    psend->setSize(preceive->getSize());
		    delete preceive;
		    allocNew = false;
		} else {
	            psend = preceive;
		    allocNew = true;
		}
		if(serverChar8ArrayDebug) {
		    char buffer[100];

		    sprintf(buffer,"serverChar8Array %s psend %p\n",
			    psend->value,psend);
		    printf("%s",buffer);
		}
	        pMessageServer->reply(psend);
	    }
	}
    }
}
